/*
 * @Author: fxs bjnsfxs@163.com
 * @Date: 2024-08-20 14:24:58
 * @LastEditors: fxs bjnsfxs@163.com
 * @LastEditTime: 2024-09-12 17:45:31
 * @FilePath: \Game-Backstage-Management-System\src\router\appManage.ts
 * @Description:
 *
 */
import type { RouteLocationNormalized, NavigationGuardNext } from 'vue-router'
export default [
  {
    path: '/appManage',
    redirect: '/appManage/gameBaseInfo',
    name: 'AppManage',
    children: [
      {
        path: 'gameBaseInfo',
        name: 'GameBaseInfo',
        icon: 'Memo',
        cnName: '基本信息',
        component: () => import('@/views/AppManage/BaseInfoView.vue'),
        meta: {
          activeMenu: 'gameBaseInfo',
          needKeepAlive: true
        }
      },
      {
        path: 'eventManage',
        name: 'EventManage',
        icon: 'Management',
        cnName: '事件管理',
        showChild: false,
        component: () => import('@/views/AppManage/EventManageView.vue'),
        redirect: '/appManage/eventManage/eventTable',
        meta: {
          needKeepAlive: false,
          activeMenu: 'eventManage'
        },
        children: [
          {
            path: 'eventDetail', // 注意：这里没有使用动态参数，而是使用查询参数
            name: 'EventDetail',
            component: () => import('@/views/AppManage/EventDetailsView.vue'),
            beforeEnter: (
              to: RouteLocationNormalized,
              from: RouteLocationNormalized,
              next: NavigationGuardNext
            ) => {
              // next()
              if (!from.name || to.fullPath === '/appManage/eventManage/eventDetail') {
                // 当页面刷新（即没有来源路由）时，重定向到 /eventManage/eventTable
                next({ path: '/appManage/eventManage/eventTable' })
              } else {
                next()
              }
            }
          },
          {
            path: 'eventTable',
            name: 'EventTable',
            component: () => import('@/views/AppManage/EventMangeTable.vue')
          }
        ]
      }
    ]
  }
]
