/*
 * @Author: fxs bjnsfxs@163.com
 * @Date: 2024-08-20 14:06:49
 * @LastEditors: fxs bjnsfxs@163.com
 * @LastEditTime: 2024-09-06 16:59:23
 * @FilePath: \Game-Backstage-Management-System\src\router\index.ts
 * @Description:
 *
 */
import { createRouter, createWebHashHistory } from 'vue-router'

import { authToken } from '@/utils/axios/auth'

import HomeRoutes from './home'
import LoginRoutes from './login'
import AppManage from './appManage'

const routes = [
  ...LoginRoutes,
  {
    path: '/index',
    name: 'Index',
    redirect: '/index/home/overView',
    component: () => import('@/views/Index.vue'),
    children: [...HomeRoutes, ...AppManage]
  },
  {
    path: '/',
    redirect: '/home/overView'
  }
]

const router = createRouter({
  history: createWebHashHistory(),
  routes
})

router.beforeEach((to, from, next) => {
  if (from) {
    // 毫无意义，但是不加from，会导致from没有使用从而导致打包错误
  }

  if (to.name === 'Login') {
    next()
  } else {
    authToken()
      .then(() => {
        next()
      })
      .catch(() => {
        router.push('login')
      })
  }
})
export default router
